unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComObj, ShlObj, ActiveX, StdCtrls, Spin;

type
  TForm1 = class(TForm)
    ButtonCreationRaccourci: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    EditNomFichier: TEdit;
    EditNomRaccourci: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    ButtonNomFichier: TButton;
    ButtonNomRaccourci: TButton;
    Label3: TLabel;
    ButtonTrouverNomFichier: TButton;
    EditDemarrerEn: TEdit;
    Label4: TLabel;
    ButtonDemarrerEn: TButton;
    EditFichierIcone: TEdit;
    Label5: TLabel;
    ButtonParcourirFichierIcone: TButton;
    SpinEdit1: TSpinEdit;
    Label6: TLabel;
    procedure ButtonCreationRaccourciClick(Sender: TObject);
    procedure ButtonNomFichierClick(Sender: TObject);
    procedure ButtonNomRaccourciClick(Sender: TObject);
    procedure ButtonTrouverNomFichierClick(Sender: TObject);
    procedure ButtonDemarrerEnClick(Sender: TObject);
    procedure ButtonParcourirFichierIconeClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
{$R *.DFM}

procedure CreFicLien(FicSource, FicRaccourci, Description, DossierDeTravail,
                     NomIconeAssociee :string; NumIcone:integer);
var
  ShellLink : IShellLink;
begin
  if UpperCase(extractFileExt(FicRaccourci))<>'.LNK' then
     FicRaccourci:=FicRaccourci+'.lnk'; // si on a oubli de mettre l'extension on l'ajoute
  ShellLink:=CreateComObject(CLSID_ShellLink) as IShellLink;
  ShellLink.SetDescription(PAnsiChar(Description));
  ShellLink.SetPath(PAnsiChar(FicSource));
  ShellLink.SetWorkingDirectory(PAnsiChar(DossierDeTravail));
  ShellLink.SetShowCmd(SW_SHOW);
  if (NomIconeAssociee<>'') then ShellLink.SetIconLocation(PAnsiChar(NomIconeAssociee), NumIcone);
  (ShellLink as IpersistFile).Save(StringToOleStr(FicRaccourci), true);
end;


function TrouverNomFichierPointe(FicSource:string):string;
var
  ShellLink   : IShellLink;
  RaccourciWC : array[0..MAX_PATH] of Char;
  pfd         : TWin32FindData;
begin
  if UpperCase(extractFileExt(FicSource))<>'.LNK' then
     FicSource:=FicSource+'.lnk'; // si on a oubli de mettre l'extension on l'ajoute
  ShellLink:=CreateComObject(CLSID_ShellLink) as IShellLink;
  (ShellLink as IPersistFile).Load(StringToOleStr(FicSource),STGM_READ);
  ShellLink.GetPath(RaccourciWC,Max_Path,pfd,SLGP_UNCPRIORITY);
  Result:=String(RaccourciWC);
end;

procedure TForm1.ButtonTrouverNomFichierClick(Sender: TObject);
begin
  ShowMessage(TrouverNomFichierPointe(EditNomFichier.Text));
end;


procedure TForm1.ButtonCreationRaccourciClick(Sender: TObject);
begin
 CreFicLien(EditNomFichier.Text,EditNomRaccourci.Text,'essai de cration d''un raccourci'
             ,EditDemarrerEn.Text, EditFichierIcone.Text, SpinEdit1.Value);
end;

procedure TForm1.ButtonNomFichierClick(Sender: TObject);
begin
  If Opendialog1.Execute then EditNomFichier.Text:=Opendialog1.FileName;
end;

procedure TForm1.ButtonNomRaccourciClick(Sender: TObject);
begin
  If SaveDialog1.Execute then EditNomRaccourci.Text:=SaveDialog1.Filename;
end;



procedure TForm1.ButtonDemarrerEnClick(Sender: TObject);
begin
  If SaveDialog1.Execute then EditDemarrerEn.Text:=SaveDialog1.Filename;
end;

procedure TForm1.ButtonParcourirFichierIconeClick(Sender: TObject);
begin
  If SaveDialog1.Execute then EditFichierIcone.Text:=SaveDialog1.Filename;
end;

end.
